###################################################
#Loadbar: While program is running                #
###################################################
from PyQt4 import QtGui, QtCore
from PyQt4.QtCore import Qt
from PyQt4.QtGui import *
import sys, os, time, subprocess, re, shutil
from os import remove, close
class Loader(QtGui.QDialog):
    def __init__(self, case, run, delta, write, program, pwd, start):
	global place, ru, delt, wri, sta
        ru = run
        sta = start
        delt = delta
        wri = write
	place = case
        self.prog(program, pwd, case)
        super(Loader, self).__init__()
        self.pbar = QtGui.QProgressBar(self)
        self.pbar.setGeometry(30, 40, 200, 25)
        self.setGeometry(800, 430, 280, 150)
        self.btn = QtGui.QPushButton('Cancel', self)
        self.btn.move(80, 80)
        self.btn.clicked.connect(self.doAction)
        self.step = 0
        self.setWindowTitle('Running')
        #setup timer
        self.timer = QtCore.QTimer(self)
        self.timer.timeout.connect(self.Time)
        self.completed = False
        self.term = False 

    def prog(self, program, pwd, case):
        fh = open(pwd+"/outp/Output","w")
        global p
        p = subprocess.Popen([program], cwd=case, stdout = fh, stderr = fh)
        fh.close()

    def Run(self):
        self.timer.start(100)
        return self.exec_()

    def Complete(self, completed):
        if self.completed:
            return
        self.completed = True
        self.timer.stop()
        if p.poll() == None:
            p.kill()
            completed = False
        if completed:
            self.accept()
        else:
            self.reject()

    def Time(self):
        run2 = re.findall("\d+.\d+|\d+", ru)
        delta2 = re.findall("\d+.\d+|\d+", delt)
        write2 = re.findall("\d+.\d+|\d+", wri)
        start2 = re.findall("\d+.\d+|\d+", sta)
        run3 = float(run2.pop())
        delta3 = float(delta2.pop())
        write3 = float(write2.pop())
        start3 = float(start2.pop())
        tot = (run3-start3)/delta3/write3
        #Counts the number of folders in case folder
        x = subprocess.Popen("ls -d */", bufsize = 1, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.PIPE, cwd = place, shell = True)
        count = 0
        #Gives a % of completed "folders"
        if x.stdout:
            for line in x.stdout:
                count += 1
        if count == 4:
            self.step = 0
        else:
            self.step = (float(count-4)/tot)*100
        self.pbar.setValue(self.step)
        QtGui.qApp.processEvents()
        if p.poll() is not None:
            self.Complete(True)
        if self.term == True:
            p.kill()
            self.Complete(False)

    def doAction(self):
        #Kills the process if cancel is pressed
        self.term = True
        p.kill()
        self.deleteLater()

